﻿
using WingAIDiagnosisService.Carotid.Utilities;
using WingAIDiagnosisService.Carotid.Utilities.DetectPlaque;

namespace WingAIDiagnosisService.Carotid
{

    /// <summary>
    /// 内膜识别结果
    /// </summary>
    public class CarotidAIMeasureResult
    {
        /// <summary>
        /// 识别内膜的结果
        /// </summary>
        public DetectIntimaResult IntimaResult { get; set; }

        /// <summary>
        /// 识别到的斑块
        /// </summary>
        public DetectPlaqueResult PlaqueResult { get; set; }

        /// <summary>
        /// 获得Y型切面图像是否成功
        /// </summary>
        public bool IsYImageSuccess { get; set; }

        public CarotidAIMeasureResult() { }

        public CarotidAIMeasureResult(DetectIntimaResult antIntima, DetectPlaqueResult plaque, bool isYImageSuccess)
        {
            IntimaResult = antIntima;
            PlaqueResult = plaque;
            IsYImageSuccess = isYImageSuccess;
        }
    }


}
