﻿
using WingAIDiagnosisService.Carotid.CarotidInterFacesData;

namespace WingAIDiagnosisService.Carotid.Utilities
{
    public class ModelEdgeChecker
    {
        //精度要求
        private readonly double _precision;

        //x最大值
        private double _xEdge;
        //y最大值
        private double _yEdge;
        //z最大值
        private double _zEdge;

        private readonly double _negativeEdge;

        public ModelEdgeChecker(ModelSize modelSize)
        {
            _negativeEdge = MathTools.MathToolsBasis.NegPrecision;
            _precision = MathTools.MathToolsBasis.Precision;
            _xEdge = modelSize.ModelLengthX - 1 + _precision;
            _yEdge = modelSize.ModelLengthY - 1 + _precision;
            _zEdge = modelSize.ModelLengthZ - 1 + _precision;
        }

        public bool IsInModel(Vector3D point)
        {
            return point.X > _negativeEdge && point.X < _xEdge && point.Y > _negativeEdge && point.Y < _yEdge &&
                   point.Z > _negativeEdge && point.Z < _zEdge;
        }

        //重设边界值
        public void ResetEdge(int x, int y, int z)
        {
            _xEdge = x + _precision;
            _yEdge = y + _precision;
            _zEdge = z + _precision;
        }
    }
}
