using System.Collections.Generic;
using System.Linq;
using AI.Common;
using AI.DiagSystem;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace WingAIDiagnosisService.Manage
{
    public class DiagnosisPerImageModel : AIDiagnosisPerImageModel
    {
        public string RemedicalCode { get; set; }

        public DataType DataType { get; set; }

        public double Pixel { get; set; }

        public string LocalVidPath { get; set; }

        public string AILocalImagePath { get; set; }

        public bool IsVinnoVid => DataType == DataType.VinnoVidSingle || DataType == DataType.VinnoVidMovie;

        /// <summary>查询结果中的病灶集合</summary>
        /// <returns></returns>
        public List<int> GetLabels()
        {
            return DiagResultsForEachOrgan.SelectMany(x => x.DetectedObjects).Select(x => x.Label).Distinct().ToList();
        }
    }
}